<template>
  <div class="w-full banner-style-02">
    <div class="w-full py-2 md:py-4 !overflow-x-hidden">
      <swiper
        v-if="!bannerLoading"
        :slides-per-view="1"
        :space-between="8"
        :centered-slides="true"
        :pagination="paginationConfig"
        :loop="themeBannerForDisplay.length > 1 ? true : false"
        :modules="modules"
        :looped-slides="3"
        :initial-slide="0"
        :allow-touch-move="false"
        class="width-custom"
        :autoplay="{ delay: 4000, disableOnInteraction: false }"
        @slide-change-transition-end="onSlideChangeTransitionEnd"
      >
        <swiper-slide
          v-for="(item, index) in themeBannerForDisplay"
          :key="index"
        >
          <nuxt-link :id="ID.LOBBY_BANNER[item.HtmlId]" :to="item.HyperLink">
            <div class="img-container rounded-lg pointer-events-none">
              <img
                :src="item.ImagePath"
                class="mx-auto relative object-cover w-full h-full rounded-lg"
                loading="lazy"
              />
            </div>
          </nuxt-link>
        </swiper-slide>
        <div class="swiper-pagination"></div>
      </swiper>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { Autoplay, Navigation, Pagination } from "swiper";
import "swiper/css";
import "swiper/css/pagination";
import _ from "lodash";
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { store } from "@/store";

const bannerKeys: Record<string, string> = {
  Home: "lobby_banner",
  sports: "sport_banner_",
  virtualsports: "virtual_sport_banner_",
  livecasino: "live_casino_banner_",
  games: "game_banner_",
  poker: "poker_banner_",
  cockfight: "cockfight_banner_",
  promotion: "promotion_banner_",
  lottery: "lottery_banner_",
};
export default defineComponent({
  name: "MobileBannerOverflow",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    actived: {
      type: String,
      default: "Home",
    },
    themeBannerForDisplay: {
      type: Array as PropType<ThemePropertiesFromApiDto[]>,
      required: true,
    },
    isIndependent: Boolean,
  },
  emits: ["hasBanner"],
  setup(props, { emit }) {
    const { actived } = toRefs(props);
    const themeName = computed((): string => store.state.selectedThemeName);
    const bannerKey = computed(() => {
      if (props.isIndependent) return bannerKeys.Home;
      return bannerKeys[actived.value]
        ? bannerKeys[actived.value]
        : bannerKeys.Home;
    });
    const bannerLoading = computed(
      () => props.themeBannerForDisplay.length === 0
    );
    const { themeColor } = themePropertyHelper;
    const theme = themeColor.value.Text;
    const paginationConfig = {
      el: ".swiper-pagination",
      clickable: true,
    };
    const onSlideChangeTransitionEnd = (swiper) => {
      swiper.slides[swiper.activeIndex].classList.add("animate-slide");
      const nextSlideIndex = (swiper.activeIndex + 1) % swiper.slides.length;
      swiper.slides[nextSlideIndex].classList.add("animate-slide");
      const lastSlideIndex =
        (swiper.activeIndex - 1 + swiper.slides.length) % swiper.slides.length;
      swiper.slides[lastSlideIndex].classList.add("animate-slide");
    };

    return {
      bannerLoading,
      bannerKey,
      modules: [Autoplay, Pagination, Navigation],
      themeName,
      paginationConfig,
      theme,
      onSlideChangeTransitionEnd,
    };
  },
});
</script>
<style lang="scss">
@keyframes slide {
  0% {
    transform: translateX(0);
  }
  50% {
    transform: translateX(-15px);
  }
  100% {
    transform: translateX(0);
  }
}
.banner-style-02 {
  .swiper.width-custom {
    height: 144px !important;
    padding: 0 16px !important;
  }

  .animate-slide {
    animation: slide 0.5s ease-in-out;
  }
  .blur-background {
    filter: none !important;
  }
  .swiper-pagination {
    align-items: center;
    display: flex !important;
    position: relative;
    bottom: 25px;
    margin-left: auto;
    transform: translateX(-8px);
    z-index: 2;
    width: fit-content;
    height: 16px;
    gap: 4px;
    padding: 4px 8px;
    border-radius: 16px;
  }
  .swiper-pagination::after {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    border-radius: 16px;
    z-index: -1;
    background: var(--background5);
    opacity: 50%;
  }
  .swiper-pagination-bullet {
    background-color: var(--text5) !important;
    opacity: 1 !important;
    border: none !important;
    transition: background-color 0.3s ease !important;
    width: 4px !important;
    height: 4px !important;
  }

  .swiper-pagination-bullet-active {
    border: 2px var(--primary) solid !important;
    background: transparent !important;
    height: 8px !important;
    width: 8px !important;
    border-radius: 50% !important;
  }
  .swiper-slide-prev,
  .swiper-slide-next {
    filter: grayscale(80%);
    opacity: 0.8;
  }
}
</style>
